.\" $XConsortium: panner.man /main/4 1995/07/17 10:48:10 drk $
...\" @OPENGROUP_COPYRIGHT@
...\" COPYRIGHT NOTICE
...\" Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
...\" Copyright (c) 1996, 1997, 1998, 1999, 2000 The Open Group
...\" ALL RIGHTS RESERVED (MOTIF).  See the file named COPYRIGHT.MOTIF for
...\" the full copyright text.
...\" 
...\" This software is subject to an open license. It may only be
...\" used on, with or for operating systems which are themselves open
...\" source systems. You must contact The Open Group for a license
...\" allowing distribution and sublicensing of this software on, with,
...\" or for operating systems which are not Open Source programs.
...\" 
...\" See http://www.opengroup.org/openmotif/license for full
...\" details of the license agreement. Any use, reproduction, or
...\" distribution of the program constitutes recipient's acceptance of
...\" this agreement.
...\" 
...\" EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS
...\" PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
...\" KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT LIMITATION, ANY
...\" WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY
...\" OR FITNESS FOR A PARTICULAR PURPOSE
...\" 
...\" EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT
...\" NOR ANY CONTRIBUTORS SHALL HAVE ANY LIABILITY FOR ANY DIRECT,
...\" INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
...\" DAMAGES (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED
...\" AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
...\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
...\" ANY WAY OUT OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE
...\" EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF ADVISED OF THE
...\" POSSIBILITY OF SUCH DAMAGES.
...\" 
...\" 
...\" HISTORY
.TH panner 1X MOTIF "Demonstration programs"
.SH NAME
\fBpanner\fR\(emVirtual screen support demo
.SH SYNOPSIS
.sS
\fBpanner\fR
.sE
.SH DESCRIPTION
Panner demonstrates how an application can interface to Mwm's virtual
screen support protocol.  The protocol allows other application to pan
the desktop Mwm is running on.  With Panner, you can see a miniature
version of your desktop and interactively pan the display. Panner
also allows you to connect to other displays and pan them as well.
Please use this feature with discretion; it can be most anoying to
others >:-).  Also note that Panner will only work with Mwm 2.0.
.PP
Panner starts up displaying notebook widget with one page.  Each page
in the notebook represents a display screen.  As you add other
displays to Panner, they appear as new pages in the notebook.  In the
notebook page, you should see several colored rectangles. Each
rectangle represents a window on the display.  The is also a dashed
rectangle which represents the display screen.  You can grab hold of
this rectangle using Button1 and interactively move it about the page
causing the display to pan.  If you wish to quickly 'hop' to another
location on the desktop, press Button1 on the destination and the
screen will be centered around that point.
.PP
The Display item in the menu bar contains the following items:
.PP
\fBUpdate\fR            This will refresh the notebook page and
.br
                redraw each miniature window.
.PP
\fBNew Display\fR       This will prompt you for the name of a new
.br
                Display connection name.
.PP
In Mwm's Virtual Screen Protocol, it is possible to 'pin' windows so
that they are not effected by the panning.  This can be done by using
the following Mwm resources:
.PP
\fBclientPinned\fR      Tells Mwm to ignore a particular
.br
                client's window(s) when panning windows.
.PP
\fBiconPinned\fR        Tells Mwm to ignore a particular
.br
                client's icon(s) when panning windows.
.PP
Since you do not want to have Panner move while you are panning,
you must tell Mwm to pin the panner window using the following
line in your \fB.Xdefaults\fR file:
.PP
        \fBMwm*Panner*ClientPinned:    True\fR
.PP
To find out more about Mwm's Virtual Screen Protocol, see the
\*VOSF/Motif Programmer's Reference, Revision 2.0\fR or the associated
\*VOSF/Motif User's Guide, Revision 2.0\fR.
.PP
If you wish to interactively pin and unpin windows, there is a new,
but unsupported function in Mwm call \fBf.toggle_pin_state\fR.  This function
can be added to a window's menu and allows you to pin and unpin
windows.
.PP
There are five associated resources. These resources modify the label
used in the window menu to show the state of the window.  The default
for this label is to display the string "make pinned" when the
associated window is not pinned, and "make unpinned" when it is
pinned.  You can specify a new set of labels or pixmaps using the
following resources:
.PP
\fBpinStateLabelType\fR This specifies the label type.
.br
                        \fBXmPIXMAP\fR  Displays a pixmap 
.br
                                        using \fBpinnedPixmap\fR
.br
                                        and unpinnedPixmap.
.PP
                        \fBXmSTRING\fR  Displays text 
.br
                                        using \fBpinnedString\fR
.br
                                        and \fBunpinnedString\fR.
.PP
\fBpinnedString\fR              This specifies the string to display
.br
                        when the \fBpinStateLabelType\fR is 
.br
                        \fBXmSTRING\fR and the associated window
.br
                        is pinned.
.PP
\fBunpinnedString\fR            This specifies the string to display
.br
                        when the \fBpinStateLabelType\fR is
.br
                        \fBXmSTRING\fR and the associated window
.br
                        is unpinned.
.PP
\fBpinnedPixmap\fR              This specifies the pixmap to display
.br
                        when the \fBpinStateLabelType\fR is
.br
                        \fBXmPIXMAP\fR and the associated window
.br
                        is pinned.
.PP
\fBunpinnedPixmap\fR            This specifies the pixmap to display
.br
                        when the \fBpinStateLabelType\fR is
.br
                        \fBXmPIXMAP\fR and the associated window
.br
                        is unpinned.
.PP
----------
.br
Enjoy,
.br
Andrew deBlois
